#!/opt/perl-5.7.3/bin/perl

use warnings;
use strict;
use Encode;
use Encode::HTMLEntities;

binmode STDIN, ":utf8";

print entify(<>);

sub encode_handwritten {
    my($encoding, $string, $check) = @_;
    die "Can only encode to [html-entities] encoding" unless $encoding eq 'html-entities';
    $string =~ s/([^\x00-\x7f])/'&#'.ord($1).';'/eg;
    return $string;
}

sub entify {
    return map {encode('html-entities', $_, Encode::FB_HTMLCREF)} @_;
}

sub entify1 {
    my @data = @_;
    my @res;
    foreach my $string (@data) {
        my $octets = '';
        while (length $string) {
            my $ori = $string;
            my $encoded = encode('html-entities', $string, Encode::FB_HTMLCREF);
            unless (defined $encoded) {
                print STDERR "before: $ori\nafter: $string\n";
            }
            $octets .= $encoded;
            if (length $string) {
                $octets .= encode_handwritten('html-entities',
                    substr($string, 0, 1, ''));
            }
        }
        push @res, $octets;
    }
    return @res;
}
